package ru.karelia.cs.petrsugen.application;

import java.io.InputStream;
import java.util.Properties;

public class AppConfiguration {
    private static InputStream in;
    private static Properties props = null;

    public static void init() {
        props = new Properties();
        
    }

    public static String getOutputPath() {
        return props.getProperty("outputPath");
    }

    public static String getDefaultInputFile() {
        return props.getProperty("defaultInputFile");
    }

    public static void setDefaultInputFile(String value) {
        //Properties props = AppConfiguration.loadConfFile();
        props.setProperty("defaultInputFile", value);
    }

    public static boolean getGenerateDependencies() {
        return props.getProperty("generateDependencies").equals("yes")?true:false;
    }

    public static void setGenerateDependencies(boolean value) {
        //Properties props = AppConfiguration.loadConfFile();
        props.setProperty("generateDependencies", value?"yes":"no");
    }

    public static void setOutputPath(String value) {
        //Properties props = AppConfiguration.loadConfFile();
        System.out.println("Output path changed from "+props.getProperty("outputPath")+" to "+value);
        props.setProperty("outputPath", value);
    }

    public static void setFullPathToTemplates(String value) {
        //Properties props = AppConfiguration.loadConfFile();
        props.setProperty("fullPathToTemplates", value);
    }

    public static void setOutputLanguage(String value) {
        //Properties props = AppConfiguration.loadConfFile();
        props.setProperty("outputLanguage", value);
    }

    public static String getFullPathToTemplates() {
        return props.getProperty("fullPathToTemplates");
    }

    public static String getOutputLanguage() {
        return props.getProperty("outputLanguage");
    }

    public static String getTestProgram() {
        return props.getProperty("testProgram");
    }

    public static void setTestProgram(String value) {        
        if ( value == null ) {
            //value = "disabled";
            value = "enabled";
        }
        props.setProperty("testProgram", value);
    }

    
    public static String getMainFile() {
        return props.getProperty("mainFile");
    }

    public static void setMainFile(String value) {        
        if ( value == null ) {
            value = "enabled";
        }
        props.setProperty("mainFile", value);
    }

    public static String getMakeFile() {
        return props.getProperty("makeFile");
    }

    public static void setMakeFile(String value) {        
        if ( value == null ) {
            value = "enabled";
        }
        props.setProperty("makeFile", value);
    }
     

    public static String getDoxyFile() {
        return props.getProperty("doxyFile");
    }

    public static void setDoxyFile(String value) {        
        if ( value == null ) {
            value = "enabled";
        }
        props.setProperty("doxyFile", value);
    }
     

    
    public static String getTripleStore() {
        return props.getProperty("triplestore");
    }

    public static void setTripleStore(String value) {        
        if ( value == null ) {
            value = "enabled";
        }
        props.setProperty("triplestore", value);
    }
    

    private static Properties getProperties() {
        return props;
    }
    
    public static String getDefaultMiddlewareFile() {
        return props.getProperty("defaultMiddlewareFile");
    }

    public static String getDefaultOntologyUtilFile() {
        return props.getProperty("defaultOntologyUtilFile");
    }
}
