package ru.karelia.cs.petrsugen.application;

import java.io.File;
import ru.karelia.cs.petrsugen.util.Logger;
import ru.karelia.cs.petrsugen.application.Generator;

/**
 * 
 * 
 */
public class Main {

    Logger log;

    /**
     * @param args
     *            the command line arguments
     */
    public static void main(String[] args) {
        //Analyze input parameters

        boolean gui = false;
        String inputFile = null;
        String outputPath = null;        
        String mainFile = ""; 
        String makeFile = "";
        String doxyFile = "";
        String testProgram = null;       
        String triplestore = null;

        if (args.length == 0) {
        	//gui is disabled
        	//printHelp();
        	// GUI disabled !
            //Gui g = new Gui();
            //g.setVisible(true);
            //gui = true;
        } else if (args.length == 1) {
            if (args[0].equals("-h") || args[0].equals("--help") || args[0].equals("/?")) { // Now we have it all
                printHelp();
            } else {
                inputFile = args[0];
            }
        } else if (args.length >= 1) {
            inputFile = args[0];
            int current = 1; // parameter to be evaluated
            while (args.length > current) {
                if (args[current].equals("-o")) {
                    current++;
                    outputPath = new File(args[current]).getAbsolutePath();
                    outputPath += File.separator;
                } else if (args[current].equals("-t")) {
					current++;
                	triplestore = args[current];                   
                } else if (args[current].equals("-tp")) {
					current++;
                	testProgram = args[current];  
                       	
                } else if (args[current].equals("-m")) {
					current++;
                	mainFile = args[current];          
                } else if (args[current].equals("-k")) {
					current++;
                	makeFile = args[current];              
                                            
                } else if (args[current].equals("-d")) {
					current++;
                	doxyFile = args[current];              

                } else {
                    printHelp();
                }
                current++;
            }
        }

       
      	if ((outputPath == null) || (inputFile == null)) {
      		printHelp();            	            	
        } else {
        	File f = new File(inputFile);
        	File p = new File(outputPath);
        	if (f.exists() && (p.exists())){         		
        		System.out.println("Input file: " + inputFile);
        		System.out.println("Output path: " + outputPath);
        		Generator generator = new Generator();
        		
        		generator.runGenerator(new Logger("Code generator", true), inputFile, outputPath, triplestore, testProgram, mainFile, makeFile, doxyFile);
        	} else {
        		if (!f.exists())
        			System.out.println("Input file does not exists: " + inputFile);
        		if (!p.exists())
        			System.out.println("outputPath does not exists: " + outputPath);
        		
        		
        	}
        }
        //}
    }

    private static void printHelp() {
        // Now we have it all
        System.out.println("Usage: java -jar CodeGenerator file [-o path] [options]");
        System.out.println("");
        System.out.println("Options:");
        System.out.println("    file             Input ontology in XML/RDF format.");
        System.out.println("    -o path          Output path. Defaults to path of input file.");  
        //System.out.println("    -t triplestore 	 enabled(default) / disabled.");
        //System.out.println("    -tp TestProgram	 enabled / disabled (default).");
        System.out.println("    -m main 	 	 Generate KP template(kp), enabled(default) disabled.");
        System.out.println("    -k Makefile 	 Generate Makefile, enabled(default) / disabled.");
        //System.out.println("    -d Doxyfile 	 Generate doxyfile, enabled(default) / disabled.");
    }






















}
