package ru.karelia.cs.petrsugen.framework;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import com.hp.hpl.jena.util.FileUtils;

import ru.karelia.cs.petrsugen.application.AppConfiguration;

public class CCodeModelContainer {
	// private ArrayList<String> defs = new ArrayList<String>();
	// private ArrayList<String> impl = new ArrayList<String>();
	private String defs = null;
    private String cdefs = null;
	private String impl = null;
	private String testProgram = null;
	private BufferedWriter implementationWriter = null;
	private BufferedWriter definitionWriter = null;
    private BufferedWriter cdefinitionWriter = null;
	private BufferedWriter testProgramWriter = null;
	private String headerFile = null;
    private String cDefsFile = null;
	private String sourceFile = null;
	private String testProgramFile = null;
	public CCodeModelContainer() {
		// create streams
		defs = new String();
        cdefs = new String();
		impl = new String();
		testProgram = new String();
		String suffix = FileUtils.getFilenameExt(AppConfiguration.getDefaultInputFile());
		String inputFile = FileUtils.getBasename(AppConfiguration.getDefaultInputFile());
				
		inputFile = inputFile.substring(0, inputFile.length()-(suffix.length() +1 ));
		
		System.out.println("inputfile : " + inputFile);
				
		this.headerFile = inputFile + ".h";		
		this.sourceFile = inputFile + ".c";
	        this.cDefsFile = inputFile + "_entities.c";
		
		try {
			implementationWriter = new BufferedWriter(new FileWriter(
					AppConfiguration.getOutputPath() + sourceFile));
			definitionWriter = new BufferedWriter(new FileWriter(
					AppConfiguration.getOutputPath() + headerFile));
            cdefinitionWriter = new BufferedWriter(new FileWriter(
					AppConfiguration.getOutputPath() + cDefsFile));
		

			if (AppConfiguration.getTestProgram().toLowerCase().equals("enabled")){
//				testProgramFile = "test_program.c";
//				testProgramWriter = new BufferedWriter(new FileWriter(
//						AppConfiguration.getOutputPath() + testProgramFile));
						
				
			}

			System.out.println("after writers");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public String getHeaderFile() {
		return this.headerFile;

	}

	public String getSourceFile() {
		return this.sourceFile;

	}

	public void addDef(String def) {
		this.defs = this.defs.concat(def);		
	}

    
    public void addCDef(String def) {
		this.cdefs = this.cdefs.concat(def);
	}


	public void addImpl(String imp) {
		this.impl = this.impl.concat(imp);
	}

	public void addTests(String tests) {
		this.testProgram = this.testProgram.concat(tests);

	}

	
	public void writeDefs() {

		try {

			definitionWriter.write(this.defs.toString());
			definitionWriter.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}


    public void writeCDefs() {

		try {

			cdefinitionWriter.write(this.cdefs.toString());
			cdefinitionWriter.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}


	public void writeImpl() {

		try {			
			implementationWriter.write(this.impl.toString());
			implementationWriter.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void writeTestProgram() {

		try {

			testProgramWriter.write(this.testProgram.toString());
			testProgramWriter.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}


	
	public void write() {
		this.writeDefs();
     //   this.writeCDefs();
		this.writeImpl();
		if (AppConfiguration.getTestProgram().toLowerCase().equals("enabled")){
//			this.writeTestProgram();
		}
	}

}
