package ru.karelia.cs.petrsugen.handlers.cHandlers;

import com.hp.hpl.jena.ontology.OntProperty;

import ru.karelia.cs.petrsugen.framework.CCodeModelContainer;
import ru.karelia.cs.petrsugen.handlers.Handler;
import ru.karelia.cs.petrsugen.templates.TemplateResourceFile;
import ru.karelia.cs.petrsugen.util.CodeGenerationUtils;
import ru.karelia.cs.petrsugen.util.TemplateString;

/**
 *
 * 
 */
public class CDatatypePropertyHandler extends Handler {

	public static void handle(OntProperty op, CCodeModelContainer writer,
			String className) {
				
		
		TemplateString propertys = new TemplateString(TemplateResourceFile.getTemplate("CDatatypePropertyDefinition"));
		String dpName = CodeGenerationUtils.removeUri(op.getLocalName())
				.toLowerCase();
		String dpType = "xsdstring"; // this is a hack, so that all xsd  datatypes becomes char pointers ingenerated code
		
		//dpType = CodeGenerationUtils.removeUri(op.getRange().toString());
		propertys.replaceTag("<@classname@>", className);
		propertys.replaceTag("<@propertyname@>", dpName);
		// if (de.getType() != null)
		propertys.replaceTag("<@propertytype@>", dpType);
		propertys.removeTags();

		writer.addDef(propertys.getString());

		/* Generate the implementation part of the property */

		propertys = new TemplateString(TemplateResourceFile.getTemplate("CDatatypePropertyImplementation"));
		propertys.replaceTag("<@propertynamereal@>", op.getNameSpace()
				+ op.getLocalName());
		propertys.replaceTag("<@classname@>", className);
		propertys.replaceTag("<@propertyname@>", dpName);
		
		propertys.replaceTag("<@propertytype@>", dpType);
		//if (op.getRange()!= null)
		dpType = CodeGenerationUtils.removeUri(op.getRange().toString());
		
		propertys.replaceTag("<@propertytypeuppercase@>", "XSD"+dpType.toUpperCase());
		
		//propertys.replaceTag("<@xsdtype@>", "^^dpType);
		propertys.removeTags();

		writer.addImpl(propertys.getString());

	}

}
