package ru.karelia.cs.petrsugen.handlers.cHandlers;


import com.hp.hpl.jena.ontology.OntProperty;

import ru.karelia.cs.petrsugen.framework.CCodeModelContainer;
import ru.karelia.cs.petrsugen.templates.TemplateResourceFile;
import ru.karelia.cs.petrsugen.util.CodeGenerationUtils;
import ru.karelia.cs.petrsugen.util.TemplateString;


public class CObjectPropertyHandler {

	static String templateName = TemplateResourceFile.getTemplate("CObjectPropertyDefinition");
	static String templateName2 = TemplateResourceFile.getTemplate("CObjectPropertyImplementation");

	public static void handle(OntProperty op, CCodeModelContainer writer,
			String className) {
		
		//generate to the .h file
		TemplateString propertys = new TemplateString(templateName);
		String opType;
		String opName = CodeGenerationUtils.removeUri(op.getLocalName())
				.toLowerCase();

		opType = "xsdstring";

    	//opType = CodeGenerationUtils.removeUri(op.getRange().toString()).toLowerCase();
		propertys.replaceTag("<@classname@>", className);
		propertys.replaceTag("<@propertyname@>", opName);

		propertys.replaceTag("<@propertytype@>", opType);
		
		propertys.removeTags();

		writer.addDef(propertys.getString());
		//generate to the .c file
		propertys = new TemplateString(templateName2);
		propertys.replaceTag("<@propertynamereal@>", op.getNameSpace()
				+ op.getLocalName());
		
		propertys.replaceTag("<@classname@>", className);
		propertys.replaceTag("<@propertyname@>", opName);
		
		propertys.replaceTag("<@propertynameuppercase@>", opName.toUpperCase());
		//propertys.replaceTag("<@propertytype@>", opType);
		propertys.removeTags();

		writer.addImpl(propertys.getString());

	}

}
