package ru.karelia.cs.petrsugen.util;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import ru.karelia.cs.petrsugen.util.TemplateString;
import ru.karelia.cs.petrsugen.application.AppConfiguration;

import ru.karelia.cs.petrsugen.mediator.MediatorResourceFile;

import ru.karelia.cs.petrsugen.templates.TemplateResourceFile;

public class CBuildGenerator {
//	static String makeFileTemplateName = Template.getTemplate("CMakefile");
    static String ResourcePath = "/ru/karelia/cs/petrsugen/templates/";
	static String doxyFileTemplateName = TemplateResourceFile.getTemplate("Doxyfile");
	static String mainFileTemplateName = TemplateResourceFile.getTemplate(ResourcePath + "OntMain");
	static String outPutPath = AppConfiguration.getOutputPath();



	private static void GenerateUtilFile(String fileName){
		BufferedWriter writer = null;

		try {
			writer = new BufferedWriter(new FileWriter(AppConfiguration
					.getOutputPath()
					+ fileName));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		
		try {
			writer.write(MediatorResourceFile.getResourceFile(fileName));
			writer.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
	}
	
	public static void GenerateMediator(){
		String cFileName = "generic.c";
		GenerateUtilFile(cFileName);
		String hFileName = "generic.h";
		GenerateUtilFile(hFileName);
		cFileName = "mediator.c";
		GenerateUtilFile(cFileName);
		hFileName = "mediator.h";
		GenerateUtilFile(hFileName);		
		
		
	}
	
	
	public static void GenerateMakeFile(String sourceFile, String headerFile) {
		/*
		String makeFileTemplateName = "";
		if (AppConfiguration.getTestProgram().toLowerCase().equals("enabled")){
			makeFileTemplateName = TemplateResourceFile.getTemplate("CTestMakefile");
		} else {
			makeFileTemplateName = TemplateResourceFile.getTemplate("CMakefile");
		}*/
		String makeFileTemplateName = TemplateResourceFile.getTemplate(ResourcePath + "OntMakefile");
		BufferedWriter writer = null;

		try {
			writer = new BufferedWriter(new FileWriter(AppConfiguration
					.getOutputPath()
					+ "Makefile"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		String libName = "lib" + sourceFile.replaceFirst("\\.c", ".a");
		String objName = sourceFile.replaceFirst("\\.c", ".o");
	        String objOntName = sourceFile.replaceFirst("\\.c", "_entities.o");
		String linkName = sourceFile.replaceFirst("\\.c", "");
		
		TemplateString makeFile = new TemplateString(makeFileTemplateName);

		makeFile.replaceAll("<@linkname@>", linkName);
		makeFile.replaceAll("<@libname@>", libName);
		makeFile.replaceAll("<@libobject@>", objName);
		makeFile.replaceAll("<@libontobject@>", objOntName);
        makeFile.replaceAll("<@sourcefile@>", sourceFile);
		makeFile.replaceAll("<@headerfile@>", headerFile);
		
		try {
			writer.write(makeFile.getString());
			writer.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public static void GenerateDoxyFile(String headerFile) {
		BufferedWriter writer = null;

		try {
			writer = new BufferedWriter(new FileWriter(AppConfiguration
					.getOutputPath()
					+ "Doxyfile"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		TemplateString doxyFile = new TemplateString(doxyFileTemplateName);
		doxyFile.replaceAll("<@headerfile@>", headerFile);
		try {
			writer.write(doxyFile.getString());
			writer.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	
	public static void GenerateMainFile(String headerFile) {
		BufferedWriter writer = null;

		try {
			writer = new BufferedWriter(new FileWriter(AppConfiguration
					.getOutputPath()
					+ "kp.c"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		TemplateString mainFile = new TemplateString(mainFileTemplateName);
		mainFile.replaceAll("<@headerfile@>", headerFile);
		try {
			writer.write(mainFile.getString());
			writer.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
