
package ru.karelia.cs.petrsugen.util;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

/**
 *
 * @author akaustel
 */
public class Logger {

    private LinkedList<LogEntry> log;
    private String name;
    private static String nl = "\r\n";
    private boolean writeFile = false;

    public Logger(String name, boolean writeFile) {
        this.log = new LinkedList<LogEntry>();
        this.name = name;
        this.writeFile = writeFile;
    }

    public String getName() {
        return this.name;
    }

    public void error(String data) {
        log.addLast(new LogEntry(data, LogEntry.LogLevel.Error));
    }

    public void info(String data) {
        log.addLast(new LogEntry(data, LogEntry.LogLevel.Info));
    }

    public void warning(String data) {
        log.addLast(new LogEntry(data, LogEntry.LogLevel.Warning));
    }

    public void writeFile(String fileName) {
        try {
            BufferedWriter writer = new BufferedWriter(new FileWriter(fileName));
            writer.write("Logger output for "+this.name+nl+"================================================="+nl);
            for (LogEntry e : this.log) {
                writer.write(e.toString()+nl);
            }
            writer.flush();
            writer.close();
        } catch (IOException iOException) {
            System.err.println("Writing log to file failed: "+iOException);
        }
    }

    /**
     * @return the writeFile
     */
    public boolean isWriteFile() {
        return writeFile;
    }

    /**
     * @param writeFile the writeFile to set
     */
    public void setWriteFile(boolean writeFile) {
        this.writeFile = writeFile;
    }
}
